= nng_msg_header_insert(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_msg_header_insert - prepend to message header

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

int nng_msg_header_insert(nng_msg *msg, const void *val, size_t size);
int nng_msg_header_insert_u16(nng_msg *msg, uint16_t val16);
int nng_msg_header_insert_u32(nng_msg *msg, uint32_t val32);
int nng_msg_header_insert_u64(nng_msg *msg, uint64_t val64);
----

== DESCRIPTION

The `nng_msg_header_insert()` family of functions
prepends data to the front of the headers of message _msg_, reallocating
if necessary.
The first function prepends _size_ bytes, copying them from _val_.
The remaining functions prepend the specified value (such as _val32_) in
network-byte order (big-endian).

== RETURN VALUES

These functions return 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists.

== SEE ALSO

[.text-left]
xref:nng_msg_alloc.3.adoc[nng_msg_alloc(3)],
xref:nng_msg_header.3.adoc[nng_msg_header(3)],
xref:nng_msg_header_append.3.adoc[nng_msg_header_append(3)],
xref:nng_msg_header_chop.3.adoc[nng_msg_header_chop(3)],
xref:nng_msg_header_len.3.adoc[nng_msg_header_len(3)],
xref:nng_msg_header_trim.3.adoc[nng_msg_header_trim(3)],
xref:nng_msg_free.3.adoc[nng_msg_free(3)],
xref:nng_msg_realloc.3.adoc[nng_msg_realloc(3)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng.7.adoc[nng(7)]
